]> git.ipfire.org Git - thirdparty/systemd.git/commitdiff
test: add test for setting service manager environment variables
authorLennart Poettering <lennart@poettering.net>
Mon, 26 Nov 2018 20:16:27 +0000 (21:16 +0100)
committerYu Watanabe <watanabe.yu+github@gmail.com>
Tue, 27 Nov 2018 05:25:17 +0000 (14:25 +0900)
This is a follow-up for #10594. I somehow forgot to commit this when I
worked on that.

test/TEST-26-SETENV/Makefile [new symlink]
test/TEST-26-SETENV/test.sh [new file with mode: 0755]
test/TEST-26-SETENV/testsuite.sh [new file with mode: 0755]

diff --git a/test/TEST-26-SETENV/Makefile b/test/TEST-26-SETENV/Makefile
new file mode 120000 (symlink)
index 0000000..e9f93b1
--- /dev/null
@@ -0,0 +1 @@
+../TEST-01-BASIC/Makefile
\ No newline at end of file
diff --git a/test/TEST-26-SETENV/test.sh b/test/TEST-26-SETENV/test.sh
new file mode 100755 (executable)
index 0000000..fb9c189
--- /dev/null
@@ -0,0 +1,42 @@
+#!/bin/bash
+# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
+# ex: ts=8 sw=4 sts=4 et filetype=sh
+set -e
+TEST_DESCRIPTION="test setenv"
+
+. $TEST_BASE_DIR/test-functions
+
+test_setup() {
+    create_empty_image
+    mkdir -p $TESTDIR/root
+    mount ${LOOPDEV}p1 $TESTDIR/root
+
+    (
+        LOG_LEVEL=5
+        eval $(udevadm info --export --query=env --name=${LOOPDEV}p2)
+
+        setup_basic_environment
+
+        # setup the testsuite service
+        cat >$initdir/etc/systemd/system/testsuite.service <<EOF
+[Unit]
+Description=Testsuite service
+
+[Service]
+ExecStart=/bin/bash -x /testsuite.sh
+Type=oneshot
+StandardOutput=tty
+StandardError=tty
+NotifyAccess=all
+EOF
+        cp testsuite.sh $initdir/
+
+        setup_testsuite
+    ) || return 1
+    setup_nspawn_root
+
+    ddebug "umount $TESTDIR/root"
+    umount $TESTDIR/root
+}
+
+do_test "$@"
diff --git a/test/TEST-26-SETENV/testsuite.sh b/test/TEST-26-SETENV/testsuite.sh
new file mode 100755 (executable)
index 0000000..2d93cb4
--- /dev/null
@@ -0,0 +1,33 @@
+#!/bin/bash
+# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
+# ex: ts=8 sw=4 sts=4 et filetype=sh
+set -ex
+set -o pipefail
+
+# Make sure PATH is set
+systemctl show-environment | grep -q '^PATH='
+
+# Let's add an entry and override a built-in one
+systemctl set-environment PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/testaddition FOO=BAR
+
+# Check that both are set
+systemctl show-environment | grep -q '^PATH=.*testaddition$'
+systemctl show-environment | grep -q '^FOO=BAR$'
+
+systemctl daemon-reload
+
+# Check again after the reload
+systemctl show-environment | grep -q '^PATH=.*testaddition$'
+systemctl show-environment | grep -q '^FOO=BAR$'
+
+# Drop both
+systemctl unset-environment FOO PATH
+
+# Check that one is gone and the other reverted to the built-in
+! (systemctl show-environment | grep -q '^FOO=$')
+! (systemctl show-environment | grep -q '^PATH=.*testaddition$')
+systemctl show-environment | grep -q '^PATH='
+
+echo OK > /testok
+
+exit 0